<template>
  <v-text-field
    :model-value="displayValue"
    class="[&_input]:text-center [&_.v-field]:px-0"
    hide-spin-buttons
    :hide-details="!isDefined(hint) && !isDefined(error)"
    :persistent-hint="isDefined(hint) || isDefined(error)"
    :error-messages="error ? [error] : []"
    type="text"
    inputmode="decimal"
    lang="ru"
    :density="density"
    :hint="hint"
    :min="min"
    :max="max"
    :step="step"
    :autofocus="autofocus"
    @input="onInput"
    @focus="isInputFocused = true"
    @blur="isInputFocused = false"
  >
    <template #prepend-inner>
      <v-btn
        icon="mdi-minus"
        variant="plain"
        class="block !h-full rounded"
        @click="onDecreaseClick"
      />
    </template>

    <template #append-inner>
      <v-btn
        icon="mdi-plus"
        variant="plain"
        class="block !h-full rounded-none"
        @click="onIncreaseClick"
      />
    </template>
  </v-text-field>
</template>

<script setup lang="ts">
import { computed, ref, watch } from 'vue';
import { isDefined } from '@/utils';

type NumberInputMode = 'price' | 'integer';
type NumberInputDensity = 'default' | 'compact';

type NumberInputProps = {
  modelValue: number;
  step: number;
  mode: NumberInputMode;
  density?: NumberInputDensity;
  hint?: string;
  min?: number;
  max?: number;
  error?: string;
  autofocus?: boolean;
}

const props = defineProps<NumberInputProps>();
const emit = defineEmits(['update:modelValue']);

const replaceDots = (value: string | number) => {
  return String(value).replace('.', ',').replaceAll('.', '');
};

const replaceCommas = (value: string) => {
  return value.replace(',', '.').replaceAll(',', '');
};

const applyInputMode = (value: string | number) => {
  const targetValue = props.mode === 'price'
    ? parseFloat(String(value)).toFixed(2)
    : String(Math.trunc(Number(value)));

  emit('update:modelValue', Number(targetValue));
  return replaceDots(targetValue);
};

const isInputFocused = ref(false);
const displayValue = computed(() => {
  const value = isInputFocused.value
    ? String(props.modelValue)
    : applyInputMode(props.modelValue);

  return replaceDots(value);
});

const onInput = (event: InputEvent) => {
  const target = event.target as HTMLInputElement;

  const value = Number(replaceCommas(target.value));
  const result = !isNaN(value) ? value : 0;

  emit('update:modelValue', result);
};

const onDecreaseClick = () => {
  const nextValue = props.modelValue - props.step;
  const isLowerThanMin = isDefined(props.min) && nextValue < props.min!;

  emit('update:modelValue', isLowerThanMin ? props.min : nextValue);
};

const onIncreaseClick = () => {
  const nextValue = props.modelValue + props.step;
  const isHigherThanMax = isDefined(props.max) && nextValue > props.max!;

  emit('update:modelValue', isHigherThanMax ? props.max : nextValue);
};

watch(() => props.modelValue, value => {
  if (!isDefined(value)) {
    return emit('update:modelValue', props.min ?? 0);
  }

  if (value < props.min!) {
    return emit('update:modelValue', props.min);
  }

  if (value > props.max!) {
    return emit('update:modelValue', props.max);
  }
});
</script>

<style scoped>
.\!h-full {
  height: 100% !important;
}
</style>